from __future__ import annotations

from collections.abc import Mapping
from typing import Any, TypeVar, cast

from attrs import define as _attrs_define
from attrs import field as _attrs_field

from ..types import UNSET, Unset

T = TypeVar("T", bound="LegacytypesAssigneeTasks")


@_attrs_define
class LegacytypesAssigneeTasks:
    """
    Attributes:
        field_id (str | Unset):
        completed_tasks (int | Unset):
        projects (list[str] | Unset):
        started_tasks (int | Unset):
        total_tasks (int | Unset):
    """

    field_id: str | Unset = UNSET
    completed_tasks: int | Unset = UNSET
    projects: list[str] | Unset = UNSET
    started_tasks: int | Unset = UNSET
    total_tasks: int | Unset = UNSET
    additional_properties: dict[str, Any] = _attrs_field(init=False, factory=dict)

    def to_dict(self) -> dict[str, Any]:
        field_id = self.field_id

        completed_tasks = self.completed_tasks

        projects: list[str] | Unset = UNSET
        if not isinstance(self.projects, Unset):
            projects = self.projects

        started_tasks = self.started_tasks

        total_tasks = self.total_tasks

        field_dict: dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update({})
        if field_id is not UNSET:
            field_dict["_id"] = field_id
        if completed_tasks is not UNSET:
            field_dict["completed_tasks"] = completed_tasks
        if projects is not UNSET:
            field_dict["projects"] = projects
        if started_tasks is not UNSET:
            field_dict["started_tasks"] = started_tasks
        if total_tasks is not UNSET:
            field_dict["total_tasks"] = total_tasks

        return field_dict

    @classmethod
    def from_dict(cls: type[T], src_dict: Mapping[str, Any]) -> T:
        d = dict(src_dict)
        field_id = d.pop("_id", UNSET)

        completed_tasks = d.pop("completed_tasks", UNSET)

        projects = cast(list[str], d.pop("projects", UNSET))

        started_tasks = d.pop("started_tasks", UNSET)

        total_tasks = d.pop("total_tasks", UNSET)

        legacytypes_assignee_tasks = cls(
            field_id=field_id,
            completed_tasks=completed_tasks,
            projects=projects,
            started_tasks=started_tasks,
            total_tasks=total_tasks,
        )

        legacytypes_assignee_tasks.additional_properties = d
        return legacytypes_assignee_tasks

    @property
    def additional_keys(self) -> list[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
